.386
.model flat,stdcall
option casemap:none

include tstDialog.inc
.const
	;definitons of the controls' id:
	TxtHostID      equ 1003
	TxtBeginPortID equ 1005
	TxtEndPortID   equ 1007
	TxtLogID       equ 1008
	CmdStartID     equ 1001
	tID1           equ 2004

	CZero          equ 48
	WM_SOCKET      equ WM_USER+100
.data
	
	sin            sockaddr_in    <>
	wsadata        WSADATA        <>
	HTxtHost       DWORD          ?
	HTxtBeginPort  DWORD          ?
	HTxtEndPort    DWORD          ?
	HTxtLog        DWORD          ?
	HCmdStart      DWORD          ?
	buffer         db             "255.255.255.255",0
	LogB           db             4096 dup (?)
	ThisPort       WORD           ?
	ConText        db             16 dup(?)
	CRLF           db             "-"
	OpenT          db             "Open port-",0
	CloseT         db             "Closed port-",0
    NetworkNotReady db            "No network connection",0
	BeginPort      WORD           ?
    EndPort        WORD           ?
    InvalidVersion db             "No winsock 1.1 support by current winsock dll",0
.data?
	sock           dd             ?

.code

start:

	invoke         GetModuleHandle,NULL
	mov            hInstance,eax
	invoke         GetCommandLine
	invoke         InitCommonControls
    invoke         WinMain,hInstance,NULL,CommandLine,SW_SHOWDEFAULT
	invoke         ExitProcess,eax

;This procedure shows appends the current port to the Log Box.
ShowPort proc
	xor            eax,eax
	mov            ax,ThisPort
	invoke         dwtoa,eax,ADDR ConText
	invoke         GetWindowText,HTxtLog,ADDR LogB,4096
	invoke         lstrcat,ADDR LogB,ADDR ConText
	invoke         lstrcat,ADDR LogB,ADDR CRLF
	invoke         SetWindowText,HTxtLog,ADDR LogB
	ret
ShowPort endp
;This procedure appends "port is open" to the Log Box.
ShowOpen proc
	invoke         GetWindowText,HTxtLog,ADDR LogB,4096
	invoke         lstrcat,ADDR LogB,ADDR OpenT
	invoke         SetWindowText,HTxtLog,ADDR LogB
	ret
ShowOpen endp
;This procedure clears the Log Box.
ClearLog proc
	invoke          SetWindowText,HTxtLog,NULL
	ret
ClearLog endp
;This procedure appends "port is closed" to the Log Box.
ShowClose proc
	invoke          GetWindowText,HTxtLog,ADDR LogB,4096
	invoke          lstrcat,ADDR LogB,ADDR CloseT
	invoke          SetWindowText,HTxtLog,ADDR LogB
	ret
ShowClose endp
;This procedure connects the socket to "ThePort" in the address that is in the Sin struct
;As defined in the beginning of the program.
ConByPort proc 
	pop             ebx                      ;to keep the last value of the stack in ebx.
	mov             sin.sin_family, AF_INET
	invoke          htons, ThisPort          ; convert port number into network byte order first
    mov             sin.sin_port,ax          ; note that this member is a word-size param.
    invoke          connect,sock,ADDR sin,sizeof sin
    invoke          SetTimer,hWnd,tID1,1000,NULL ;no need in a time function.
    
	.if ThisPort>EndPort
    	invoke          closesocket, sock
    	.if             eax==SOCKET_ERROR
    	                                             ;<put your error handling code here>
		.endif
	.endif
	jmp             @Over
@Cont:	invoke          ShowPort
@Over:	push            ebx
	ret
ConByPort Endp
;The famous WinMain procedure.
;creates the dialog box and manages the message loop.
WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
	LOCAL	        wc:WNDCLASSEX
	LOCAL	        msg:MSG

	mov				wc.cbSize,SIZEOF WNDCLASSEX
	mov				wc.style,CS_HREDRAW or CS_VREDRAW
	mov				wc.lpfnWndProc,OFFSET WndProc
	mov				wc.cbClsExtra,NULL
	mov				wc.cbWndExtra,DLGWINDOWEXTRA
	push	        hInst
	pop				wc.hInstance
	mov				wc.hbrBackground,COLOR_BTNFACE+1
	mov				wc.lpszMenuName,OFFSET MenuName
	mov				wc.lpszClassName,OFFSET ClassName
	invoke          LoadIcon,NULL,IDI_APPLICATION
	mov				wc.hIcon,eax
	mov				wc.hIconSm,eax
	invoke          LoadCursor,NULL,IDC_ARROW
	mov				wc.hCursor,eax
	invoke          RegisterClassEx,addr wc
	invoke          CreateDialogParam,hInstance,addr DlgName,NULL,addr WndProc,NULL
	invoke          ShowWindow,hWnd,SW_SHOWNORMAL
	invoke          UpdateWindow,hWnd
	
    invoke          WSAStartup, 101h,addr wsadata   ;Starting the Winsock DLL:
	.if eax==NULL
                .WHILE TRUE
                        INVOKE GetMessage, ADDR msg,NULL,0,0
                        .BREAK .IF (!eax)
                        invoke IsDialogMessage,hWnd,addr msg
                        .if eax==FALSE
                                INVOKE TranslateMessage, ADDR msg
                                INVOKE DispatchMessage, ADDR msg
                       .endif
                .ENDW
                invoke WSACleanup               
        .else
                .if eax==WSASYSNOTREADY
                        invoke MessageBox,hWnd,addr NetworkNotReady,addr AppName,MB_OK+MB_ICONERROR
                .else
                        invoke MessageBox,hWnd,addr InvalidVersion,addr AppName,MB_OK+MB_ICONERROR
                .endif                                                  
        .endif
        mov     eax,msg.wParam
        ret
WinMain endp

LoadPorts proc
	
	invoke GetWindowText,HTxtBeginPort,ADDR buffer,16
	invoke atodw,ADDR buffer
	mov BeginPort,ax
	invoke GetWindowText,HTxtEndPort,ADDR buffer,16
	invoke atodw,ADDR buffer
	mov EndPort,ax
	ret

LoadPorts endp

WndProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

    LOCAL TIP:BYTE
    LOCAL TDX:DWORD
    LOCAL Len:DWORD
	
	mov	eax,uMsg
	.if uMsg==WM_INITDIALOG
		push	hWin
		pop		hWnd
		invoke GetDlgItem,hWnd,TxtHostID
		mov HTxtHost,eax
		invoke GetDlgItem,hWnd,TxtBeginPortID 
		mov HTxtBeginPort,eax
		invoke GetDlgItem,hWnd,TxtEndPortID 
		mov HTxtEndPort,eax
		invoke GetDlgItem,hWnd,TxtLogID 
		mov HTxtLog,eax	
		invoke GetDlgItem,hWnd,CmdStartID 
		mov HCmdStart,eax
	.elseif uMsg==WM_TIMER
		invoke closesocket,sock
		invoke KillTimer,hWnd,tID1
		inc ThisPort
		invoke ConByPort
	.elseif uMsg==WM_COMMAND
		mov eax,wParam
		.if ax==CmdStartID						;The start button was clicked.
			invoke ClearLog
			invoke LoadPorts 					;Load ports to their variables as numbers.
			invoke socket,AF_INET,SOCK_STREAM,0     ; Create a stream socket for internet use
			.if eax!=INVALID_SOCKET  ;everything went OK.
    			mov sock,eax
    			invoke WSAAsyncSelect, sock, hWnd,WM_SOCKET, FD_CONNECT+FD_READ+FD_CLOSE
            	; Register interest in connect, read and close events.
				.if eax==SOCKET_ERROR
    					    ;<put your error handling routine here>
				.else ;everything is OK.
					invoke GetWindowText,HTxtHost,ADDR buffer,sizeof buffer
					;Load the Host Name only one time:
					invoke inet_addr, ADDR buffer    ; convert the IP address into network byte order
					
					mov sin.sin_addr,eax
					mov ax,BeginPort
					mov ThisPort,ax
    				invoke ConByPort
				.endif
			.else
    			invoke WSAGetLastError
			.endif
		.endif
	.elseif uMsg==WM_SOCKET
		invoke KillTimer,hWnd,tID1
		mov eax,lParam
		.if ax==FD_CONNECT
			shr eax,16        ;The error code (if any) is in the high word of lParam 
            .if ax==NULL ;	  ;We got a connection! 
            	invoke ShowOpen
            .else 			  ;Connection attempt failed. 
            	invoke ShowClose
            .endif 
			inc ThisPort
			invoke ConByPort
		.elseif    ax==FD_CLOSE 
			invoke ShowClose
        .endif 
	.elseif eax==WM_CLOSE
		invoke DestroyWindow,hWin
	.elseif uMsg==WM_DESTROY
		invoke PostQuitMessage,NULL
	.else
		invoke DefWindowProc,hWin,uMsg,wParam,lParam
		ret
	.endif
	xor    eax,eax
	ret

WndProc endp

end start
